 	
autowatch=1;
inlets=1;
outlets=4;


//	*	{ ÒvÓ}  *   
//		/)""")   *  
//------->>->>-----
//Embodme EraeTouch API for Max by Ema Nymton v1.0a
//

//This Javascript Files Handles messages between your EraeTouch(es)
//It has to run as a Max Patch outside Ableton because it doesn't support sysexin and sysexout in a signle patch
//To bypass this I translated the sysexin (finger data,zone size data etc)
//And the output data (Api enable/Disable,get size, draw pixel, clear zone)
//Into simple OSC messages

//CONSTANTS
var EraeTouchIdentifier=[0x00,0x21,0x50,0x00,0x01,0x00,0x01,0x01,0x01,0x04]
var ReceiverPrefixBytes=0X7D;
var OSCPrefix="Erae";
var current_zone=-1
var fingersDataPlane= new JitterMatrix(5,"float32",1,10);
//var fingersPosition= new JitterMatrix(3,"float32",1,10);

var zonesizes=[];

function prefix(p){OSCPrefix=p;}




//███████╗██╗   ██╗███████╗███████╗██╗  ██╗     ██████╗ ██╗   ██╗████████╗
//██╔════╝╚██╗ ██╔╝██╔════╝██╔════╝╚██╗██╔╝    ██╔═══██╗██║   ██║╚══██╔══╝
//███████╗ ╚████╔╝ ███████╗█████╗   ╚███╔╝     ██║   ██║██║   ██║   ██║   
//╚════██║  ╚██╔╝  ╚════██║██╔══╝   ██╔██╗     ██║   ██║██║   ██║   ██║   
//███████║   ██║   ███████║███████╗██╔╝ ██╗    ╚██████╔╝╚██████╔╝   ██║   
//╚══════╝   ╚═╝   ╚══════╝╚══════╝╚═╝  ╚═╝     ╚═════╝  ╚═════╝    ╚═╝   


                                                                    
                                                                        



//---SEND EVERY SYSEX MESSAGE OUT--------------------------
function sysexout(a){
var msg=[];
msg=arrayfromargs(arguments);

var sysexmsg=[];

	sysexmsg=concat([0xF0],EraeTouchIdentifier);
	sysexmsg=concat(sysexmsg,msg[0]);
	sysexmsg=concat(sysexmsg,[0xF7]);
outlet(0,sysexmsg);


}

//CONCATENATE TWO LIST OF DATA--------------------------
function concat(msg1,msg2){
var list=[];
	for(i=0;i<msg1.length;i++){list.push(msg1[i]);} 
	for(i=0;i<msg2.length;i++){list.push(msg2[i]);} 
return list;
}

//---ENABLE OR DISABLE API MODE--------------------------
function API_enable(bool){
var sysexmsg=[];
	//enable	
	if(bool){
		sysexmsg[0]=0x01;
		sysexmsg[1]=ReceiverPrefixBytes;
	}
	//disable
	else{sysexmsg[0]=0x02;}
		
sysexout(sysexmsg);
}

//---ASK API ZONE SIZE (Zone Boundary Request message)-------------------------
function getsize(zone){
var sysexmsg=[];

sysexmsg[0]=0x10;
sysexmsg[1]=zone;

sysexout(sysexmsg);
}


//---CLEAR API ZONE PIXELS-------------------------
function clear(zone){
var sysexmsg=[0x20,zone];

sysexout(sysexmsg);
}

//---RECEIVE 1 PIXEL COMPRESSED DATA--------------------
//consisting of 2 int32
//pos contains : ZONE,X,Y
//color contains the RGB values

//---ASK API ZONE SIZE (Zone Boundary Request message)-------------------------




//---DRAW SEVERAL PIXEL IN A SINGLE IN A DEFINED AREA (max=32 pixels)
function DrawImage(a){
	
var blob= arrayfromargs(arguments);
var service=0x23;
var zone=blob[0];
var X=blob[1];
var Y=blob[2];
var Width=blob[3];
var Heigth=blob[4];
var binary=blob.slice(5,blob.length);
var sysex_binary=[];

//Exemple :

//4 pixels = 12 Bytes
// R0 G0 B0 R1 G1 B1 R2 G2 B2 R3 G3 B3
// FF FF FF FF 00 00 00 FF 00 00 00 FF

// should become 14bytes in sysex format:
// 0  1  2  3  4  5  6  7  8  9  10 11 12 13	
// X0 R0 G0 B0 R1 G1 B1 R2 X1 G2 B2 R3 G3 B3
// 78 7F 7F 7F 7F 00 00 00 44 7F 00 00 00 7F

//Here 78 and 44 are the missing bytes
//they contain the MSB of the 7 following color bytes : 0b0ABCDEFG
//every 8 bytes the first one is the complement
//so we need to create that byte every 7 bytes
var i;
var j=0;
	for (i=0;i<(binary.length);i++){
		j=(i-(i%7))/7;
		
		if((i+j)%8==0){sysex_binary[i+j]=0;}//set to 0 before adding the MSB bits
		
		
		//get the integer part of i/7 to offset the sysexbinary
		//in other word increment j by 1 every 7 bytes
		
		//---MSB-------------
		sysex_binary[j*8]+=(binary[i]&0x80)>>(i%8+1);
		//0bAaaaaaaa & 0x80(Ob10000000)
		//>>i bit shift right for each 7 bytes
		//j*8 -> add it to every the first of every 8 bytes: 0,8,16,
		
		//RGB values without their MSB
		sysex_binary[i+j+1]=binary[i]&0x7F;//bitmask Ob01111111
		//j offset by one the position every 7 bytes
	}
//add the XOR Checksum at the end
i++
sysex_binary[i+j]=chk8xor(sysex_binary);

//add the drawn area's location
var endmsg=concat([service,zone,X,Y,Width,Heigth],sysex_binary);

sysexout(endmsg);
}



//
function chk8xor(byteArray) {

  checksum = 0x00;
  	for(i = 0; i < byteArray.length; i++){
    	checksum ^= byteArray[i];
	}
  return checksum;

}





//---ASK API ZONE SIZE (Zone Boundary Request message)-------------------------
function zone_size(zone) {
var sysexmsg=[0x23,zone];
sysexout(sysexmsg);
}


function pixel(pos,color){
	
var ZONE=(pos>>11)%0X80;
var X=(pos>>5)%0x40;
var Y=pos%0x20;

var R=(color>>14%0X80);
var G=(color>>7)%0X80;
var B=color%0X80;

//send the sysex messge to refresh the modified pixel
	sysexmsg=[0x21,ZONE,X,Y,R,G,B];
	sysexout(sysexmsg);
	
}



//███████╗██╗   ██╗███████╗███████╗██╗  ██╗    ██╗███╗   ██╗
//██╔════╝╚██╗ ██╔╝██╔════╝██╔════╝╚██╗██╔╝    ██║████╗  ██║
//███████╗ ╚████╔╝ ███████╗█████╗   ╚███╔╝     ██║██╔██╗ ██║
//╚════██║  ╚██╔╝  ╚════██║██╔══╝   ██╔██╗     ██║██║╚██╗██║
//███████║   ██║   ███████║███████╗██╔╝ ██╗    ██║██║ ╚████║
//╚══════╝   ╚═╝   ╚══════╝╚══════╝╚═╝  ╚═╝    ╚═╝╚═╝  ╚═══╝
                                                          



//---MANAGE EVERY SYSEX INPUT MESSAGES--------------------------

function sysexin(b) {
    if (b === 0xF0) { // new sysex
        receiveBuffer = [b];
    }
    else if (b === 0xF7) { // end of sysex
        receiveBuffer.push(b);
		//outlet(10,receiveBuffer);//Output entire sysex messages
		var buffer = receiveBuffer.slice(1, receiveBuffer.length - 1);//Remove begin and end
		parser(buffer);
        receiveBuffer = [];
    }
    else if (b & 0x80) {
        post("bad sysex byte, aborting receive\n");
        receiveBuffer = [];
    }
    else if (receiveBuffer.length) { // data byte, append to buffer
        receiveBuffer.push(b);
    }
}



//---PARSE SYSEX INPUT MESSAGES INTO OSC MESSAGES--------------------------

function parser(buffer){
length=buffer.length;
var msg=[];
//var prefix="";
var type=0;

	if(buffer[0]!=125){return}//if not the right Préfix Byte we stop everything
	if(buffer[1]=== 0x7F){
		if(buffer[2]=== 0x01){
			type="size";
			var zone=buffer[3];
			var x=buffer[4];
			var y=buffer[5];
			msg=["/"+OSCPrefix+"/"+zone+"/"+type+"/",x,y];
			outlet(3,x,y);
		}

	}
	else{
		type="finger";

			var action=(buffer[1] & 0x70)>>4;//&& 0b01110000 (=0x70 bit mask) and 4bitshift to the right
	
			var finger=buffer[1] & 0x0F;
			var zone=buffer[2];
			
			if(current_zone!=zone){
					current_zone=zone;
					getsize(zone);
			}
			
			var bit=[];
			var bytes=[];
			//slice the XYZ 14x7bits starting at the 5th sysex byte
			var position=buffer.slice(3,3+14);//XYZ 14x sysex bytes(7bits)

			//outlet(8,position);
			var b=0;
			for(i=0; i<14; i++){
				
				if((i%8)==0){
					var MSB=position[i];//i==0 and i==8 7bits are MSBs
		
				}
				else{
					bytes[b]=position[i];//bytes is a table of 12 bytes missing their MSBs
					//here we extract each of the 7 bits we need
					bit[b]=((MSB<<(i%8))&0x80);
					//bytes[b]=bytes[b]|bit[b];
					bytes[b]=bytes[b]+bit[b];
					b++;		
				}
			}
				//Explanation of the above formula:
					//MSB = Ob0ABCDEFG first and then MSB=0b0HIJKL0
					//we'll have to bitshift to left
						//to get ObABCDEFG0 we bitshift by 6
						//to get 0bBCDEFG00 we bitshift by 5
					//i goes from 1 to 7 since we skip 0
					//then we'll use the bitmask 0b1OOO0000=0X80
						//for example : ObABCDEFG0 &=0b1000000
					//and then we do the same thing to MSB=0b0HIJKL0 but with only on 5bits
					// finally we add either 128(=0x80) or 0 to the each of the 12 incomplete bytes
					// we increment each time up from 0 up to 11
					
			var X=f_32(bytes[0],bytes[1],bytes[2],bytes[3]);
			var Y=f_32(bytes[4],bytes[5],bytes[6],bytes[7]);
			var Z=f_32(bytes[8],bytes[9],bytes[10],bytes[11]);
			
			msg=["/"+OSCPrefix+"/"+zone+"/"+type+"/",finger,action,X,Y,Z];
			
			}
			
		outlet(1,msg);

		if(action!=2){fingersDataPlane.setcell(0,finger,"val",zone,action,X,Y,Z);}
		else{fingersDataPlane.setcell(0,finger,"val",-1,action,0,0,0);}
		outmatrix=fingersDataPlane;
		outlet(2,"jit_matrix",outmatrix.name);
		/*
		if(action!=2){fingersPosition.setcell(0,finger,"val",X,Y,Z);}
		else{fingersPosition.setcell(0,finger,"val",0,0,0);}
		outmatrix=fingersPosition;
		outlet(3,"jit_matrix",outmatrix.name);
		*/

}



//---CONVERT 4 CHAR BYTES INTO A FLOAT32--------------------------
//this is where the most horrible maths happen (O__O°;)? (Ò__Ó) (T__T)

function f_32(a,b,c,d){
//concatenate bytes like so OxAaaaaaaaBbbbb...Ddddddddd 
var i=a+(b<<8)+(c<<16)+(d<<24);
//leftmost bit is the sign
var sign=1
if(i>>31){sign=-1}
//then the exponent is the follwing 8bits
var exponent=(i>>23)&0xFF;//get the exponent byte
var mantissa=i&0x7FFFFF;//bitmask on 23bits to get the 23 mantissa bits
var mantissafrac=0;
//mantissa fraction calculation
	for(j=0; j<23; j++) {
	mantissafrac+=Math.pow(0.5,1+(22-j))*((mantissa>>j)&0x01);
	}//each bits represents a power of 1/2 from right to left;
	
//float32 final formula
var f32=sign*(Math.pow(2,(exponent-127)))*(1.+mantissafrac);
return (f32);
}







		
